<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Document</title>
</head>

<body>
    <script>
        /*
Напишите функцию, которая принимает
в себя информацию об пользователе
в виде объекта,
среди параметров которого - поля age и wantLicense,
и которая возвращает ответ - в виде строки 'Иван Иванов может получить права категории B1'
может ли человек получить
в его возрасте желаемые права или отказ в случае ограничения по возрасту или отсутствия данных параметров в запросе
Функция содержит в себе массив объектов,
описывающий разные типы водительских прав.
*/

        const user1 = {
            age: 21,
            name: 'Алексей',
            lastName: 'Михайлович',
            wantLicense: 'B1',
        };

        const user2 = {
            age: 11,
            name: 'Алексей',
            lastName: 'Михайлович',
            wantLicense: 'A2',
        };
        const driverLicense = [
                {
                    age: 16,
                    type: 'A1',
                    time: 2,
                },
                {
                    age: 16,
                    type: 'A2',
                    time: 2,
                },
                {
                    age: 18,
                    type: 'B1',
                    time: 6,
                },
                {
                    age: 18,
                    type: 'B',
                    time: 4,
                },
                {
                    age: 19,
                    type: 'BE',
                    time: 4,
                },
                {
                    age: 21,
                    type: 'D1',
                    time: 3,
                },
            ];

        const isMatch = (personAge, wantLicense, licenseList) => {
           const matchItem = licenseList.find(({type}) => wantLicense === type );
           if(!matchItem) {
               console.log('There is no such category in list');
               return false;
           }
           return  matchItem.allowedAge <= personAge;

        };


        const isLicenceAllow = ({name, lastName, age, wantLicense}) => {
          const isAllowed =  isMatch(age, wantLicense, driverLicense);
          (!isAllowed) ?
              console.log((`${name} ${lastName} не может получить права категории ${wantLicense}`)) :

              console.log(`${name} ${lastName} может получить права категории ${wantLicense}`);
        };

        isLicenceAllow(user2);




    </script>
</body>

</html>
